/*
 *	spSusie.h
 */

#ifndef __SPSUSIE_H
#define __SPSUSIE_H

#include <windows.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifdef _WIN64
#define SP_SUSIE_SUFFIX ".sph"
#else
#define SP_SUSIE_SUFFIX ".spi"
#endif

#define SP_SUSIE_ERROR_NOERROR 0
#define SP_SUSIE_ERROR_NOTSUPPORT (-1)
#define SP_SUSIE_ERROR_USERCANCEL 1
#define SP_SUSIE_ERROR_UNKNOWNFORMAT 2
#define SP_SUSIE_ERROR_BROKENDATA 3
#define SP_SUSIE_ERROR_EMPTYMEMORY 4
#define SP_SUSIE_ERROR_FAULTMEMORY 5
#define SP_SUSIE_ERROR_FAULTREAD 6
#define SP_SUSIE_ERROR_RESERVED 7
#define SP_SUSIE_ERROR_INTERNAL 8
    
#define SP_SUSIE_HEADER_BUFFER_SIZE 2048
    
#pragma pack(push,1)
typedef struct _spSusiePictureInfo {
    long left;
    long top;
    long width;
    long height;
    WORD x_density;
    WORD y_density;
    short colorDepth;
#ifdef _WIN64
    char  dummy[2];
#endif
    HLOCAL  hInfo;
} spSusiePictureInfo;
#pragma pack(pop)

typedef int (__stdcall *spSusieProgressProc)(int nNum, int nDenom, LONG_PTR lData);

typedef int (__stdcall *spSusieGetPluginInfoProc)(int infono, LPSTR buf, int buflen);
typedef int (__stdcall *spSusieIsSupportedProc)(LPCSTR filename, void *dw);
typedef int (__stdcall *spSusieConfigurationDlgProc)(HWND hWnd, int function);
typedef int (__stdcall *spSusieGetPictureInfoProc)(LPCSTR buf, LONG_PTR len, unsigned int flag, spSusiePictureInfo *lpInfo);
typedef int (__stdcall *spSusieGetPictureProc)(LPCSTR buf, LONG_PTR len, unsigned int flag, HANDLE *pHBInfo, HANDLE *pHBm, spSusieProgressProc lpPrgressCallback, LONG_PTR lData);
typedef int (__stdcall *spSusieGetPreviewProc)(LPSTR buf, LONG_PTR len, unsigned int flag, HANDLE *pHBInfo, HANDLE *pHBm, spSusieProgressProc lpPrgressCallback, LONG_PTR lData);
typedef int (__stdcall *spSusieCreatePictureProc)(LPCSTR filepath, unsigned int flag, HANDLE *pHBInfo, HANDLE *pHBm, spSusiePictureInfo *lpInfo, spSusieProgressProc progressCallback, LONG_PTR lData);

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration */
#endif

#endif /* __SPSUSIE_H */
