/*
 *	spDraw_Mac.h
 */

#ifndef __SPDRAW_MAC_H
#define __SPDRAW_MAC_H

#ifdef __cplusplus
extern "C" {
#endif

#if 0
#define SP_GWORLD_PIXMAP_ALWAYS_LOCK
#define SP_COPYBITS_USE_SET_GWORLD
#else
#undef SP_GWORLD_PIXMAP_ALWAYS_LOCK
#undef SP_COPYBITS_USE_SET_GWORLD
#endif

typedef struct _spPolygonArchPart {
    PolyHandle hpoly;
    int start_x;
    int start_y;
    int last_x;
    int last_y;
    Point *points;
} spPolygonArchPart;

#if defined(MACOS)
#pragma import on
#endif

extern spBool spOpenPictFromFSSpecMac(FSSpec *pfsspec, GraphicsImportComponent *pgic, Rect *prect);
extern spBool spDrawImportedPictToLockedGWorldMac(GWorldPtr gworld, Rect *prect, GraphicsImportComponent *pgic);
extern spBool spGetFileTypeFromGraphicsImportComponentMac(GraphicsImportComponent *pgic, OSType *pFileType);
extern GWorldPtr spLoadPictToGWorldMac(const char *basename, Rect *prect);
extern spBool spWritePictFromGWorldMac(GWorldPtr gworld, GraphicsExportComponent *pgec, FSSpec *pfsspec, OSType type);
extern PixMapHandle spGetLockedPixmapMac(spComponent component);
extern void spUnlockPixmapMac(spComponent component, PixMapHandle pixmap);
extern void spGetOriginalRGBMac(void);
extern void spSetOriginalRGBMac(void);
extern void spSetNormalRGBMac(void);
extern void spSetBackgroundRGBMac(void);
extern void spSetDeactivateRGBMac(void);
extern void spSetGraphicsMac(spGraphics graphics);
extern void spUnsetGraphicsMac(spGraphics graphics);
extern spBool spBeginDrawMac(spComponent component, spGraphics graphics,
			     PixMapHandle *current_pixmap, GWorldPtr *save_gwp, GDHandle *save_gdh);
extern spBool spEndDrawMac(spComponent component, spGraphics graphics,
			   PixMapHandle current_pixmap, GWorldPtr save_gwp, GDHandle save_gdh);
extern void spSetFontIdMac(short font_id, int style, int size);
extern void spSetFontMac(spGraphics graphics);

extern void spDrawRectangleMac(spGraphics graphics, int x, int y, int width, int height, spBool fill);
extern void spDrawArcMac(spGraphics graphics,
			 int x, int y, int width, int height, double angle1, double angle2, spBool fill);
extern void spDrawLineMac(spGraphics graphics, int x1, int y1, int x2, int y2);
extern void spDrawPointMac(spGraphics graphics, int x, int y);
extern void spDrawStringMac(spGraphics graphics, int x, int y, const char *string);
extern void spGetStringExtentMac(spGraphics graphics, const char *string,
				 int *x, int *y, int *width, int *height, int *next_x);
    
#if defined(MACOS)
#pragma import off
#endif

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration */
#endif

#endif /* __SPDRAW_MAC_H */
