/*
 *	spFrame_Mac.h
 */

#ifndef __SPFRAME_MAC_H
#define __SPFRAME_MAC_H

#ifdef __cplusplus
extern "C" {
#endif
    
typedef struct _spFrameArchPart {
    spBool realize_flag;
    spBool activate_flag;
    spComponent text;
    spComponent key_send_component;
    spComponent quit_menu_item;
    spComponent help_menu;
    
    spDropCallbackFunc drop_call_func;
    void *drop_call_data;
    
    spDrawFunc draw_func;
    spMouseFunc mouse_func;
    spKeyFunc key_func;
    spForegroundFunc foreground_func;
    spBackgroundFunc background_func;
    void *data;

#if defined(MACOSX)
    Rect system_window_rect;
    ControlDefSpec content_control_spec;
    ControlRef content_control;
#endif
} spFrameArchPart;

extern void spInvalWindowMac(WindowPtr window, ControlRef control);
extern void spAddFrameCallbackMac(spComponent component, spDrawFunc draw_func,
				  spMouseFunc mouse_func, spKeyFunc key_func,
				  spForegroundFunc foreground_func, spBackgroundFunc background_func, 
				  void *data);

#if defined(MACOSX)
extern ToolboxObjectClassRef spRegisterWithToolboxMac(void *data);
extern ControlRef spCreateSystemWindowChildMac(spComponent component, ControlDefSpec *pControlSpec);
#endif

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration */
#endif

#endif /* __SPFRAME_MAC_H */
