/*
 *	spLocale_Gtk.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <gtk/gtk.h>
#if GTK_CHECK_VERSION(3,0,0)
#include <locale.h>
#endif

#include <sp/spDefs.h>
#include <sp/spBase.h>
#include <sp/spString.h>
#include <sp/spMemory.h>

#include <sp/spLocaleP.h>

void spSetLanguageArch(const char *lang, char *o_lang)
{
#if GTK_CHECK_VERSION(3,0,0)
    sscanf(setlocale(LC_ALL, ""), "%s", o_lang);
#else
    sscanf(gtk_set_locale(), "%s", o_lang);
#endif
    spDebug(10, NULL, "locale = %s\n", o_lang);
#if GTK_CHECK_VERSION(2,0,0)
    if (spIsJapaneseLang(o_lang) == SP_TRUE) {
	strcpy(o_lang, "ja_JP.utf8");
    } 
    spDebug(10, NULL, "gtk 2.0 locale = %s\n", o_lang);
#endif
    
    return;
}
