/*
 *	spProgressBar_Win.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sp/spDefs.h>
#include <sp/spMemory.h>

#include <sp/spTopLevelP.h>
#include <sp/spProgressBarP.h>

extern spTopLevel sp_toplevel;

void spProgressBarCreateArch(spComponent component)
{
    DWORD dwStyle = WS_CHILD;

    dwStyle |= spGetVisibleStyleWin(component);

    if (SpProgressBarPart(component).segmented_flag == SP_FALSE) {
	dwStyle |= PBS_SMOOTH;
    }
    
    /* create track bar */
    SpPrimitiveArch(component).hwnd =
	CreateWindowEx(0,
		       PROGRESS_CLASS,
		       (!strnone(SpGetName(component)) ? SpGetName(component) : ""),
		       dwStyle,
		       SpComponentPart(component).x, SpComponentPart(component).y,
		       SpComponentPart(component).current_width,
		       SpComponentPart(component).current_height,
		       SpParentPrimitiveArch(component).hwnd,
		       (HMENU)SpComponentPart(component).component_id,
		       SpTopLevelArch(sp_toplevel).hThisInst,
		       NULL);
    SendMessage(SpPrimitiveArch(component).hwnd, WM_SETFONT,
		(WPARAM)SpTopLevelArch(sp_toplevel).sys_font, MAKELPARAM(TRUE, 0));

    SendMessage(SpPrimitiveArch(component).hwnd, PBM_SETRANGE,
		(WPARAM)0,
		(LPARAM)MAKELONG(SpProgressBarPart(component).minimum,
				 SpProgressBarPart(component).maximum));
    SpProgressBarPart(component).value = MAX(SpProgressBarPart(component).value,
					     SpProgressBarPart(component).minimum);
    SpProgressBarPart(component).value = MIN(SpProgressBarPart(component).value,
					     SpProgressBarPart(component).maximum);
    SendMessage(SpPrimitiveArch(component).hwnd, PBM_SETPOS,
		(WPARAM)SpProgressBarPart(component).value,
		(LPARAM)0);
    SendMessage(SpPrimitiveArch(component).hwnd, PBM_SETSTEP,
		(WPARAM)SpProgressBarPart(component).increment,
		(LPARAM)0);
    
    return;
}

void spProgressBarSetParamsArch(spComponent component)
{
    if (SpProgressBarPart(SpOldObject(component)).value != SpProgressBarPart(component).value) {
	SendMessage(SpPrimitiveArch(component).hwnd, PBM_SETPOS,
		    (WPARAM)SpProgressBarPart(component).value,
		    (LPARAM)0);
    }
    if (SpProgressBarPart(SpOldObject(component)).minimum != SpProgressBarPart(component).minimum
	|| SpProgressBarPart(SpOldObject(component)).maximum != SpProgressBarPart(component).maximum) {
	SendMessage(SpPrimitiveArch(component).hwnd, PBM_SETRANGE,
		    (WPARAM)0,
		    (LPARAM)MAKELONG(SpProgressBarPart(component).minimum,
				     SpProgressBarPart(component).maximum));
    }
    if (SpProgressBarPart(SpOldObject(component)).increment != SpProgressBarPart(component).increment) {
	SendMessage(SpPrimitiveArch(component).hwnd, PBM_SETSTEP,
		    (WPARAM)SpProgressBarPart(component).increment,
		    (LPARAM)0);
    }
    
    return;
}

void spProgressBarSetValueArch(spComponent component)
{
    SendMessage(SpPrimitiveArch(component).hwnd, PBM_SETPOS,
		(WPARAM)SpProgressBarPart(component).value,
		(LPARAM)0);
    
    return;
}

void spProgressBarIncrementArch(spComponent component, int new_value)
{
    if (new_value != SpProgressBarPart(component).value) {
	SendMessage(SpPrimitiveArch(component).hwnd, PBM_STEPIT,
		    (WPARAM)0, (LPARAM)0);
    }
    
    return;
}
